
var Ct It SPt Bt Qt Pt Nt ut mt Yt Xt Kt et grt gzt Lamt
    lam_zt lam_at v_at psit xit thet C_errt I_errt N_errt SP_errt 
    DLogC DLogI DLogSP DLogY DLogZP LogN; 

varexo e_thet e_err1t e_err2t e_err3t e_err4t;

parameters alpha beta theta dele del del2 xi omg
           h BigOmg gamma Growgr Growgz  K0K 
           mu IY  
           rho_the sig_the            
           rho11 rho12 rho13 rho14 
           rho21 rho22 rho23 rho24 
           rho31 rho32 rho33 rho34 
           rho41 rho42 rho43 rho44 
           sig_err1 sig_err2 sig_err3 sig_err4 
           a1 a2 a3 a4 a5 a6 ;

// define parameters 
load Cali_Para
load Est_Para 

set_param_value('alpha', alpha)
set_param_value('beta', beta )
set_param_value('del', del)
set_param_value('dele',dele)
set_param_value('gamma',gamma)
set_param_value('Growgr',Growgr )
set_param_value('Growgz',Growgz )
set_param_value('theta',theta)
set_param_value('IY',IY)
set_param_value('K0K',K0K)
set_param_value('omg',omg)

set_param_value('BigOmg',BigOmg)
set_param_value('h',h)
set_param_value('mu',mu)
set_param_value('del2',del2)
set_param_value('xi',xi)


set_param_value('rho_the', rho_the)
set_param_value('sig_the', sig_the)
set_param_value('sig_err1', sig_err1)
set_param_value('sig_err2', sig_err2)
set_param_value('sig_err3', sig_err3)
set_param_value('sig_err4', sig_err4)

set_param_value('rho11', rho11)
set_param_value('rho12', rho12)
set_param_value('rho13', rho13)
set_param_value('rho14', rho14)
set_param_value('rho21', rho21)
set_param_value('rho22', rho22)
set_param_value('rho23', rho23)
set_param_value('rho24', rho24)
set_param_value('rho31', rho31)
set_param_value('rho32', rho32)
set_param_value('rho33', rho33)
set_param_value('rho34', rho34)
set_param_value('rho41', rho41)
set_param_value('rho42', rho42)
set_param_value('rho43', rho43)
set_param_value('rho44', rho44)


set_param_value('a1', a1)
set_param_value('a2', a2)
set_param_value('a3', a3)
set_param_value('a4', a4)
set_param_value('a5', a5)
set_param_value('a6', a6)




%-----------------------

model(linear);
// now define the system
#gr   = Growgr/100+1; 
#gz   = Growgz/100+1; 
#ga   = (gr-1)-alpha/(1-alpha)*(gz-1)+1;
#G    = 1/beta/(1-dele)/theta-1;
#del1 = gr*gz/(beta*(1-dele))-(1-del)-xi*G; % del'
#phi_x= alpha*(1+G)/del1;                   % XY=phi_x*(epslon*)
#phi_k= 1/((1-dele)/gz/gr+dele*K0K);        % KY=phi_k*XY
#BigPhi= 1-G/(1/IY*(phi_k-1+del)*phi_x-1);  % probability of not-investing
#BY   = IY/(1-BigPhi)-alpha-xi*phi_x;       % total bubble value to output ratio
#phi_G= -(1-BigPhi)/G-1;                    % loglinearized Gt=phi_G*(et*)
#CY   = 1-IY; 

// resource constraint
CY*Ct+IY*It=Yt;


// Euler equation of investment goods producer
Pt=(1+beta)*BigOmg*gz^2*gr^2*It
   +BigOmg*gr^2*gz^2*(grt+gzt)-BigOmg*gz^2*gr^2*It(-1)
   -beta*BigOmg*gz^2*gr^2*(It(+1)+grt(+1)+gzt(+1));

// total investment 
It=alpha/(alpha+xi*phi_x+BY)*Yt
  +xi*phi_x/(alpha+xi*phi_x+BY)*(xit+Qt+Xt)
  +BY/(alpha+xi*phi_x+BY)*Bt-mu*et-Pt;

// evolution of bubble
Bt=Lamt(+1)-Lamt+Bt(+1)
  +(1-beta*(1-dele)*theta)*phi_G*et(+1)
  +(1-(1-dele)*theta)/(1-dele)/theta*mt(+1);

// evolution of tobin's q
Qt=Lamt(+1)-Lamt
  +Qt(+1)-grt(+1)-gzt(+1)
  +beta*(1-dele)*del1*(del2)/gz/gr*ut(+1)
  +xi*(1/theta-beta*(1-dele))/gz/gr*(xit(+1)+phi_G*et(+1));

// FOC for opitmal utilization
Yt-Xt+(1-beta*(1-dele)*theta)*phi_G*et=Qt+(1+del2)*ut;

// production function
Yt=alpha*(Xt+ut)+(1-alpha)*Nt;

// total capital used
Xt=(1-dele)/gz/gr*phi_k*(Kt(-1)-gzt-grt);

// cut-off
et=Pt-Qt;

// total capital stock in the end of period
Kt=-del1/phi_k*ut+(1-del)/phi_k*Xt+(1-(1-del)/phi_k)*(It-mu/phi_G*et);

// consumption optimal condition
Lamt=gr/(gr-beta*h)*(-gr/(gr-h)*Ct+h/(gr-h)*(Ct(-1)-grt))
    -beta*h/(gr-beta*h)*(-gr/(gr-h)*(Ct(+1)+grt(+1))+h/(gr-h)*Ct);

// labor supply
Lamt+Yt-Nt=psit+gamma*Nt;

// stock price
# c1=phi_k*phi_x/(phi_k*phi_x+BY);
# c2=1-c1;
SPt=c1*(Qt+Kt)+c2*Bt;

// number of bubbly firm

mt=(1-dele)*theta*(mt(-1)+thet(-1));

// sentiment shock process
thet=rho_the*thet(-1)+e_thet;

// growth rate of output
grt=0;
// growth rate of investment-specific technology
gzt=0;
// permanent investment-specific (Z) shock
lam_zt=0;

// permanent TFP shock
lam_at=0;

// transitory TFP shock
v_at=0;

// labor supply shock
psit=0;

// financial shock
xit =0;


// growth rate of inverse investmetn goods price
DLogZP=log(gz)-(Pt-Pt(-1));


// observed variables:

// growth rate of consumption
DLogC=Ct-Ct(-1)+log(gr)+C_errt;

// growth rate of output
DLogY=CY*DLogC+IY*DLogI;

// growth rate of investment
DLogI=It-It(-1)+log(gr)+I_errt;

// growth rate of stock price
DLogSP=SPt-SPt(-1)+log(gr)+SP_errt;

// Log of hours worked
LogN=Nt+log(1/4)+N_errt;

//measurement error process;

SP_errt  = rho11*SP_errt(-1)+rho12*C_errt(-1)+rho13*I_errt(-1)+rho14*N_errt(-1)+e_err1t;
C_errt   = rho21*SP_errt(-1)+rho22*C_errt(-1)+rho23*I_errt(-1)+rho24*N_errt(-1)+a1*e_err1t+e_err2t;
I_errt   = rho31*SP_errt(-1)+rho32*C_errt(-1)+rho33*I_errt(-1)+rho34*N_errt(-1)+a2*e_err1t+a3*e_err2t+e_err3t;
N_errt   = rho41*SP_errt(-1)+rho42*C_errt(-1)+rho43*I_errt(-1)+rho44*N_errt(-1)+a4*e_err1t+a5*e_err2t+a6*e_err3t+e_err4t;

end;


initval;
Ct=0; It=0; SPt=0; Bt=0; Qt=0; Pt=0; Nt=0;
ut=0; mt=0; Yt=0; Xt=0; Kt=0; et=0; grt=0; gzt=0; Lamt=0;
lam_zt=0; lam_at=0; v_at=0; psit=0; xit=0; thet=0;
DLogC=0; DLogI=0; LogN=0; DLogSP=0; DLogY=0; DLogZP=0;
end;
%==========================================================================
shocks;

var e_thet;   stderr sig_the;

var e_err1t;  stderr sig_err1;
var e_err2t;  stderr sig_err2;
var e_err3t;  stderr sig_err3;
var e_err4t;  stderr sig_err4;

end;
steady;
check;
%==========================================================================       
stoch_simul(periods=0000,
            order=1,
            hp_filter=00,
            irf=00,
            nograph,noprint);

